import React, { Component } from 'react';
import logo from './logo.svg';
import {
  Route, BrowserRouter as Router, Link
} from 'react-router-dom';
import mqtt from 'mqtt';
import './App.css'

import Home from './Home'

var client = false;

var clientConnected = false;

/*function initConnect(adresse) {
  socket = mqtt.connect(adresse);

  /*if(socket) {
    alert("SA MARCHE");
  }
  else {
    alert("SA MARCHE PAS");
  }*/

  /*socket.on('connect', function() {
    socket.subscribe('#'); // Vous avez souscrit à tous les messages du serveur !
  });

  socket.on('message', function(topic, payload) {
    document.getElementById('content').innerHTML += topic + "<br>";
  });

}*/
export class Sensor{

    constructor(data) {

      //console.log(data); // DEBUG

      this._id = data.id;
      this._name = data.name;
      this._type = data.type;
      this._err = null;

      this._data = data.data;

      if(data.data.values === undefined) {
          //this._values = data.data.value;
      }
      else {
          //this._values = data.data.values;
      }

      try {

        if(this._id === undefined) {
          throw "Erreur : (class Sensor) L'attribut _id n'est pas défini";
        }

        if(this._name === undefined) {
          throw "Erreur : (class Sensor) L'attribut _name n'est pas défini";
        }

        if(this._type === undefined) {
          throw "Erreur : (class Sensor) L'attribut _type n'est pas défini ou le type defini n'est pas <TEMPERATURE>";
        }

        /*if(this._values === undefined) {
          throw "Erreur : (class Sensor) L'attribut _values n'est pas défini";
        }*/
      }
      catch(err) {
        this._err = err;
      }

      //this._labels = data.data.labels;

      //Object.assign(this._data, data);
    }

    get id() {
      return this._id;
    }

    get name() {
      return this._name;
    }

    get type() {
      return this._type;
    }

    get value() {
      return this._data.values;
    }

    get lastValue() {

      if(typeof this._data.values === 'object' && this._data.values.length === 1) {
        return this._data.values;
      }
      else if(typeof this._data.values === 'string') {
        return this._data.values;
      }
      else if(typeof this._data.values === 'number') {
        return this._data.values;
      }
      else {
        return this._data.values[this._data.values.length-1];
      }
    }

    get lastDate() {
      if(typeof this._data.labels === 'object' && this._data.labels instanceof Date) {
        return this._data.labels.toLocaleString('fr-FR', { timeZone: 'Europe/Paris' });
      }
      else {
        return this._data.labels[this._data.labels.length-1].toLocaleString('fr-FR', { timeZone: 'Europe/Paris' });
      }
    }

    get labels() {
      return this._data.labels;
    }
}

// On déclare notre tableau de capteurs
let sensorInfo = [];

function sleep(seconds){
    var waitUntil = new Date().getTime() + seconds*1000;
    while(new Date().getTime() < waitUntil) true;
}

const Page = ({sensor}) => {

  let arr = [];

  var sensor_values_read = "";
  var type_sensor_value = "";

  switch(sensor.type) {
    case "TEMPERATURE": sensor_values_read = "Température actuelle : " + sensor.lastValue+"°C"; break;
    case "ON_OFF": sensor_values_read = "Etat de mes yeux : " + sensor.lastValue; break;
    case "PERCENT": sensor_values_read = "Pourcentage actuelle : " + sensor.lastValue+"%"; break;
  }

  switch(sensor.type) {
    case "TEMPERATURE": type_sensor_value = "Température"; break;
    case "ON_OFF": type_sensor_value = "On_off"; break;
    case "PERCENT": type_sensor_value = "Pourcentage %"; break;
  }

  if(typeof sensor.value === 'object' && sensor.value.length !== undefined) {

    /* Transformer les données dans une seul array pour chaque sensor */
    for(var i = 0; i < sensor.value.length; i++) {
        arr.push([{'labels': sensor.labels[i], 'value': sensor.value[i]}]);
    }

    var historique = arr.map(function(response) {

        var message = response;

        return (
          <tr>
          <td>
            {message[0].value}
          </td>
          <td>
            {message[0].labels.toLocaleString('fr-FR', { timeZone: 'Europe/Paris' })}
          </td>
          </tr>
        );
    });
  }

  return (
      <div><h1>{sensor_values_read} (<i>Date de dernière mise à jour : {sensor.lastDate}</i>)</h1>

      <br />

      <table border="1">
        <thead>
        <tr>
          <th colSpan={2}><h1>Historique</h1></th>
        </tr>
        <tr>
          <th>{type_sensor_value}</th>
          <th>Dernière maj</th>
        </tr>
        </thead>
        <tbody>
          {historique || <tr><td colSpan={2}>Aucun historique disponible pour ce capteur</td></tr>}
        </tbody>
      </table></div>
  );
}

class App extends Component {

  constructor(props) {
    super(props);
    this.state = { value: 'ws://127.0.0.1:8080', error: null, messages: [], capteurs: [], sensor: [] };

    this.handleChange = this.handleChange.bind(this);
    this.handleSubmit = this.handleSubmit.bind(this);
  }

  addMessage(message) {
      var updated = this.state.messages;
      updated.push(message);
      this.setState({messages: updated});
  }

  addCapteur(sensor) {
      var sensorUpdated = this.state.capteurs;
      sensorUpdated.push(sensor);
      this.setState({capteurs: sensorUpdated});
  }

  addDataSensor(sensor) {
      var sensorUpdated = this.state.sensor;
      sensorUpdated.push(sensor);
      this.setState({sensor: sensorUpdated});
  }

  getSensorLength() {
    return this.state.sensor;
  }

  getInitialState() {
      return { value: 'ws://', error: null, messages: [], capteurs: [], sensor: [] };
  }

  reset() {
    this.setState(this.getInitialState());
  }

  updateDataSensor(id, obj) {
    var newsensor = this.state.sensor;
    var data = {};
    var monSensor = {};
    data.data = obj._data;
    data.err = obj._err;
    data.name = obj._name;
    data.value = obj._value;
    data.id = obj._id;
    data.type = obj._type;
    newsensor = new Sensor(data);
    this.setState({ newsensor });
  }

  handleChange(event) {
    this.setState({value: event.target.value});
  }

  handleSubmit(event) {

    event.preventDefault();

    var debutWS = this.state.value.substring(0,5);
    var debutMQTT = this.state.value.substring(0,7);

    var self = this;

    // Si on a déjà un client démarré on l'arrête
    if(client) { client.end(); }

    // On vérifie le début de la chaine de caractère si c'est un protocol mqtt ou ws
    if(debutWS !== 'ws://' && debutMQTT !== 'mqtt://') {
      var newValue = "ws://"+this.state.value;
      self.setState({value: newValue});
    }

    // On se connecte au client avec l'adresse pré-rempli
    console.log(this.state.value);
    client = mqtt.connect(this.state.value);

    console.log(client);

    client.on('connect', function() {
      client.subscribe("#");
    });

    self.reset();

    client.stream.socket.onerror = function() {
      console.log('Disconnect');
      self.setState({error: '[Erreur 500] Erreur de connexion au serveur'});
      client && client.end();
    };

    const prefixTopic = "value/";
    var id = 1;

    var i = 0;

    var listCapteurs = [];

    Array.prototype.contains = function(obj) {
      var i = this.length;
      while (i--) {
          if (this[i] === obj) {
              return true;
          }
      }
      return false;
    }

    client.on('message', function(topic, payload, packet) {

        const obj = JSON.parse(payload.toString());

        var name = topic.replace(prefixTopic,"");

        obj.id = id;
        obj.name = name;

        if(obj.type !== "ON_OFF") {
          obj.value = parseFloat(obj.value);

          if(obj.type === "PERCENT") {
            obj.value = (Math.round(obj.value * 10) / 10)*100;
          }
          else {
            obj.value = Math.round(obj.value * 10) / 10;
          }
        }

        var firstDate = "";

        if(!listCapteurs.contains(name)) {

              var data = {};
              data.values = obj.value;
              data.labels = new Date();
              obj.data = data;

              sensorInfo = new Sensor(obj);

              console.log(sensorInfo);

              listCapteurs.push(name);

              // On ajoute nos capteurs
              self.addCapteur({

                  name: sensorInfo.name,
                  url: "/"+sensorInfo.name,
                  sensor: sensorInfo
              });

              self.addMessage({
                  key: Date.now(),
                  topic: topic,
                  payload: payload.toString(),
                  name: name,
                  value: obj.value
              });

              // on ajoute dans notre liste chaque info de capteurs
              self.addDataSensor({
                  sensor: sensorInfo
              });

              i++;
              id++;
        }
        else {

              console.log(self.getSensorLength().length);

              for(var k = 0; k < self.getSensorLength().length; k++) {

                if(self.getSensorLength()[k].sensor.name === name) {

                  var date = new Date();

                  if(typeof self.getSensorLength()[k].sensor._data.values !== "array" && self.getSensorLength()[k].sensor._data.labels instanceof Date) {
                    if(self.getSensorLength()[k].sensor.type !== 'ON_OFF') {
                      var firstValue = self.getSensorLength()[k].sensor._data.values;
                      self.getSensorLength()[k].sensor._data.values = [];
                      self.getSensorLength()[k].sensor._data.values.push(firstValue);
                      self.getSensorLength()[k].sensor._data.values.push(obj.value);
                      firstDate = self.getSensorLength()[k].sensor._data.labels;
                      self.getSensorLength()[k].sensor._data.labels = [];
                      self.getSensorLength()[k].sensor._data.labels.push(firstDate);
                      self.getSensorLength()[k].sensor._data.labels.push(date);
                    }
                    else {
                      self.getSensorLength()[k].sensor._data.values = obj.value;
                      firstDate = self.getSensorLength()[k].sensor._data.labels;
                      self.getSensorLength()[k].sensor._data.labels = [];
                      self.getSensorLength()[k].sensor._data.labels.push(firstDate);
                      self.getSensorLength()[k].sensor._data.labels.push(date);
                    }
                  }
                  else {
                    if(typeof self.getSensorLength()[k].sensor._data.values === "string" && self.getSensorLength()[k].sensor.type === 'ON_OFF') {

                      // A chaque changement des yeux
                      self.getSensorLength()[k].sensor._data.values = obj.value;
                      self.getSensorLength()[k].sensor._data.labels.push(date);

                    }
                    else
                    {
                      if(self.getSensorLength()[k].sensor._data.values.length === 10 && self.getSensorLength()[k].sensor._data.labels.length === 10) {
                        /*self.getSensorLength()[k].sensor._data.values[0].push(obj.value);
                        self.getSensorLength()[k].sensor._data.labels[0].push(date);*/
                        /*for(var m = self.getSensorLength()[k].sensor._data.values.length-1; m > 0; m--) {
                          self.getSensorLength()[k].sensor._data.values[m-1] = self.getSensorLength()[k].sensor._data.values[m];
                          self.getSensorLength()[k].sensor._data.labels[m-1] = self.getSensorLength()[k].sensor._data.labels[m];
                        }*/

                        for(var m = 0; m < self.getSensorLength()[k].sensor._data.values.length; m++) {
                            if(m !== self.getSensorLength()[k].sensor._data.values.length) {
                              self.getSensorLength()[k].sensor._data.values[m] = self.getSensorLength()[k].sensor._data.values[m+1];
                              self.getSensorLength()[k].sensor._data.labels[m] = self.getSensorLength()[k].sensor._data.labels[m+1];
                            }
                        }

                        self.getSensorLength()[k].sensor._data.values.splice(-1, 1);
                        self.getSensorLength()[k].sensor._data.labels.splice(-1, 1);
                        self.getSensorLength()[k].sensor._data.values.push(obj.value);
                        self.getSensorLength()[k].sensor._data.labels.push(date);
                      }
                      else {

                        self.getSensorLength()[k].sensor._data.values.push(obj.value);
                        self.getSensorLength()[k].sensor._data.labels.push(date);
                      }

                    }
                  }

                  console.log(self.getSensorLength()[k].sensor);

                  self.updateDataSensor(k, self.getSensorLength()[k].sensor);

               }
              }
          }
    });
}

  render() {

    /* Messages globales */
    var messageNodes = this.state.messages.map(function(message) {
        return (
            <div key={message.key} className="message"><h1>{message.value}</h1></div>
        );
    });

    // Mon Historique de messages */
    var historique = this.state.capteurs.map(function(message) {
        return (
            <div key={message.sensor.id} className="message">{message.sensor.name}</div>
        );
    });

    /* Création de link capteurs dynamique */
    var linkCapteurs = this.state.capteurs.map(function(capteurs) {

        return (
          <li key={capteurs.name} className='OK'><Link to={capteurs.url}><button type="button">{capteurs.name}</button></Link></li>
        );
    });

    /* Création de route de capteurs dynamique */
    var routeCapteurs = this.state.capteurs.map(function(capteurs) {
        return (
          <Route key={capteurs.name} path={capteurs.url} params={capteurs.sensor} render={(props) => (
            <Page sensor={capteurs.sensor} />
          )}/>
        );
    });

    return (
      <div className="App">

            <header className="App-header"><img src={logo} className="App-logo" alt="logo" /><h1 className="App-title">URL du Brocker : <form onSubmit={this.handleSubmit}><input type="text" value={this.state.value}  onChange={this.handleChange} required/></form>{this.state.error || ""}</h1></header>

            <Router>
            <div className="wrapper">

              <nav><ul role="nav">
                  <li><Link to="/home"><button type="button">Home</button></Link></li>
                  <hr />
                  <div id="dynamiqueNav">
                    <h3>Navigation</h3>
                    <ul>{linkCapteurs}</ul>
                    <hr />
                  </div>
              </ul></nav>
              <article>
                  <Route path="/home" component={Home}/>
                  <div id="messageList" className="table-block footer-push">
                    {routeCapteurs}
                    <div id="content">
                    </div>
                  </div>
              </article>
            </div>
            </Router>

            <footer>@Copyright Julien SAUTEREAU - Tout droit réservé</footer>
            </div>
          );
        }
}

export default App;
